From e8d34d11799fc79c7c53bdcd40f9b4ee7be7a2c5 Mon Sep 17 00:00:00 2001
From: guowenxue <guowenxue@gmail.com>
Date: Wed, 25 Sep 2024 17:42:22 +0800
Subject: [PATCH] Merge branch 'master' of ssh://weike-iot.com:2280/framwork

---
 openlibs/mplayer/build.sh |  196 +++++++++++++++++++++++++++++++++++-------------
 1 files changed, 143 insertions(+), 53 deletions(-)

diff --git a/openlibs/mplayer/build.sh b/openlibs/mplayer/build.sh
index e009c3c..b751cb1 100755
--- a/openlibs/mplayer/build.sh
+++ b/openlibs/mplayer/build.sh
@@ -1,45 +1,118 @@
 #!/bin/bash
 
-#+--------------------------------------------------------------------------------------------
-#|Description:  This shell script used download and compile mplayer for ARM
-#|     Author:  GuoWenxue <guowenxue@gmail.com>
-#|
-#|  Usage:
-#|      mplayer -slave -quiet test.mp4  -vo fbdev2 -vf scale -fs -zoom -x 320 -y 240 
-#|
-#|  ChangeLog:
-#|           1, Initialize 1.0.0 on 2011.04.12
-#+--------------------------------------------------------------------------------------------
+# library name and version
+# Official: http://www.mplayerhq.hu/MPlayer/releases
+LIB_NAME=MPlayer-1.4
+PACK_SUFIX=tar.xz
 
-PREFIX_PATH=`pwd`/../install
-
+# LingYun source code FTP server
 LYFTP_SRC=http://master.weike-iot.com:2211/src/
 
+# library download URL address
+LIB_URL=$LYFTP_SRC
+
+# Cross compiler for cross compile on Linux server
 CROSS_COMPILE=/opt/gcc-aarch32-10.3-2021.07/bin/arm-none-linux-gnueabihf-
 
-function msg_banner()
-{
-    echo ""
-    echo "+-----------------------------------------------------------------------"
-    echo "|  $1 "
-    echo "+-----------------------------------------------------------------------"
-    echo ""
+# compile jobs
+JOBS=`cat /proc/cpuinfo |grep "processor"|wc -l`
+
+# this project absolute path
+PRJ_PATH=$(cd $(dirname "${BASH_SOURCE[0]}") && pwd)
+
+# top project absolute path
+TOP_PATH=$(realpath $PRJ_PATH/..)
+
+# binaries install path
+PREFIX_PATH=$TOP_PATH/install
+BIN_PATH=$PREFIX_PATH/bin
+LIB_PATH=$PREFIX_PATH/lib
+INC_PATH=$PREFIX_PATH/include
+
+# check installed or not file
+INST_FILE=$PREFIX_PATH/bin/ethtool
+
+# shell script will exit once get command error
+set -e
+
+#+-------------------------+
+#| Shell script functions  |
+#+-------------------------+
+
+function pr_error() {
+    echo -e "\033[40;31m $1 \033[0m"
+}
+
+function pr_warn() {
+    echo -e "\033[40;33m $1 \033[0m"
+}
+
+function pr_info() {
+    echo -e "\033[40;32m $1 \033[0m"
 }
 
 function check_result()
 {
     if [ $? != 0 ] ; then
-       echo ""
-       echo "+-----------------------------------------------------------------------"
-       echo "|  $1 "
-       echo "+-----------------------------------------------------------------------"
-       echo ""
-       exit ;
+        pr_error "$1"
+        exit
     fi
 }
-
-function export_cross()
+# decompress a packet to destination path
+function do_unpack()
 {
+    tarball=$1
+    dstpath=`pwd`
+
+    if [[ $# == 2 ]] ; then
+        dstpath=$2
+    fi
+
+    pr_info "decompress $tarball => $dstpath"
+
+    mkdir -p $dstpath
+    case $tarball in
+        *.tar.gz)
+            tar -xzf $tarball -C $dstpath
+            ;;
+
+        *.tar.bz2)
+            tar -xjf $tarball -C $dstpath
+            ;;
+
+        *.tar.xz)
+            tar -xJf $tarball -C $dstpath
+            ;;
+
+        *.tar.zst)
+            tar -I zstd -xf $tarball -C $dstpath
+            ;;
+
+        *.tar)
+            tar -xf $tarball -C $dstpath
+            ;;
+
+        *.zip)
+            unzip -qo $tarball -d $dstpath
+            ;;
+
+        *)
+            pr_error "decompress Unsupport packet: $tarball"
+            return 1;
+            ;;
+    esac
+}
+
+function do_export()
+{
+    BUILD_ARCH=$(uname -m)
+    if [[ $BUILD_ARCH =~ "arm" ]] ; then
+        pr_warn "local($BUILD_ARCH) compile $LIB_NAME"
+        return ;
+    fi
+
+    pr_warn "cross(${CROSS_COMPILE}) compile $LIB_NAME"
+
     # export cross toolchain
     export CC=${CROSS_COMPILE}gcc
     export CXX=${CROSS_COMPILE}g++
@@ -51,7 +124,7 @@
     export OBJDUMP=${CROSS_COMPILE}objdump
     export STRIP=${CROSS_COMPILE}strip
 
-    # export cross configure 
+    # export cross configure
     export CONFIG_CROSS=" --build=i686-pc-linux --host=arm-linux "
 
     # Clear LDFLAGS and CFLAGS
@@ -59,27 +132,34 @@
     export CFLAGS=
 }
 
-function compile_mplayer()
+function do_fetch()
 {
-    SRC_NAME=MPlayer-1.4
-    PACK_SUFIX=tar.xz
-
-    if [ -f ${PREFIX_PATH}/bin/mencoder ] ; then
-        msg_banner "$SRC_NAME already compile and installed"
-        return 0;
+    if [ -e ${INST_FILE} ] ; then
+        pr_warn "$LIB_NAME compile and installed alredy"
+        exit ;
     fi
 
-    msg_banner "Start cross compile $SRC_NAME "
-
-    if [ ! -f ${SRC_NAME}.${PACK_SUFIX} ] ; then
-        #wget wget http://www.mplayerhq.hu/MPlayer/releases/${SRC_NAME}.${PACK_SUFIX}
-        wget ${LYFTP_SRC}/${SRC_NAME}.${PACK_SUFIX}
-
-        check_result "ERROR: download ${SRC_NAME} failure"
+    if [ -d $LIB_NAME ] ; then
+        pr_warn "$LIB_NAME fetch already"
+        return ;
     fi
 
-    tar -xJf ${SRC_NAME}.${PACK_SUFIX}
-    cd ${SRC_NAME}
+    if [ ! -f ${LIB_NAME}.${PACK_SUFIX} ] ; then
+        wget ${LIB_URL}/${LIB_NAME}.${PACK_SUFIX}
+        check_result "ERROR: download ${LIB_NAME} failure"
+    fi
+
+    do_unpack ${LIB_NAME}.${PACK_SUFIX}
+}
+
+function do_build()
+{
+    cd $LIB_NAME
+
+    do_export
+
+    export CFLAGS=-I${INC_PATH}
+    export LDFLAGS="-L${LIB_PATH} "
 
     ./configure --prefix=${PREFIX_PATH} --enable-cross-compile --disable-mencoder \
         --disable-gui --disable-termcap --disable-termios --disable-lirc --disable-lircc \
@@ -92,20 +172,30 @@
         --cc=${CC} --as=${AS} --ar=${AR} --nm=${NM} --ranlib=${RANLIB} \
         --target=arm-linux
 
-    check_result "ERROR: configure ${SRC_NAME} failure"
+    check_result "ERROR: configure ${LIB_NAME} failure"
 
+    #make -j ${JOBS}
     make
-    check_result "ERROR: compile ${SRC_NAME} failure"
-
-    ${STRIP} mplayer
-    make install
-
-    cd -
+    check_result "ERROR: compile ${LIB_NAME} failure"
 }
 
+function do_clean()
+{
+    rm -rf *${LIB_NAME}*
+}
 
-export_cross
+if [[ $# == 1 && $1 == -c ]] ;then
+    pr_warn "start clean ${LIB_NAME}"
+    do_clean
+    exit;
+fi
 
-compile_mplayer
+# failed on: ./libavutil/arm/intmath.h:77:5: error: impossible constraint in 'asm'
+exit;
 
+cd ../zlib/ && ./build.sh && cd -
+
+do_fetch
+
+do_build
 

--
Gitblit v1.9.1